; Intro text, obviously
on *:START:{
  linesep -s
  echo 4 -s Cursor Example Script v1.05 (c) 1999-2000 DragonZap
  echo 12 -s Please open and look at the code!
  echo 12 -s Type /confine to bring up a test window
  linesep -s
}

; This should be fairly straightforward -- it opens up the window.
alias confine {
  if ( $window($pris) == $null ) {
    window -kfp +tbn $pris -1 -1 200 200
    drawtext $pris 1 Arial 15 0 0 Click and hold the mouse here to
    drawtext $pris 1 Arial 15 0 15 lock the cursor and set it to the
    drawtext $pris 1 Arial 15 0 30 crosshairs cursor. Double-click
    drawtext $pris 1 Arial 15 0 45 to hide the cursor until you let
    drawtext $pris 1 Arial 15 0 60 go of the button. Right-click to
    drawtext $pris 1 Arial 15 0 75 throw your cursor out. Push 'x'
    drawtext $pris 1 Arial 15 0 90 to open up the mIRC remote by
    drawtext $pris 1 Arial 15 0 105 simulating a mouse click on the
    drawtext $pris 1 Arial 15 0 120 remote button.
  }
  else window -a $pris
}

; This is where we do all our DLL calls.
menu @CursorPrison {
  sclick:{
    ; Why did I use $mouse.dx - $mouse.x and $mouse.dy - $mouse.y instead
    ; of any $window functions? Well, that's the only way I know to get the
    ; X and Y position of a window's client area (the part that doesn't include
    ; the titlebar, scrollbar, border, etc.)
    dll $udll ConfineCursor $calc($mouse.dx - $mouse.x) $calc($mouse.dy - $mouse.y) $window($pris).bw $window($pris).bh
    dll $udll SetStdMouseCursor2 cross
  }
  dclick:{
    dll $udll ConfineCursor $calc($mouse.dx - $mouse.x) $calc($mouse.dy - $mouse.y) $window($pris).bw $window($pris).bh
    ; We'll force hiding it.
    dll $udll CursorVisibility *hide
  }
  uclick:{
    dll $udll ConfineCursor free
    ; RestoreCursor doesn't take any arguments, but mIRC won't let us put nothing.
    dll $udll RestoreCursor .

    ; This is just a failsafe so that the cursor isn't thrown to 0 0 coming out of a single click (so that we still can double-click)
    dll $udll CursorVisibility *show
  }
  $rightclick:; Pretty sneaky, huh? This way we can catch right-clicks without bringing up a menu. Unfortunately it beeps, and doesn't trigger uclick, but oh well.
}

alias -l rightclick {
  if ( $mouse.key & 1 ) return

  ; "I shall send thee to the four corners of the earth!"
  dll $udll MoveCursor $calc( $r(0,1) * $window(-1).w ) $calc( $r(0,1) * $window(-1).h )
}

;Here we click on the "Remote" button
on *:KEYDOWN:@CursorPrison:88:{
  ;Before clicking, the mouse cursor must be positioned on the "Remote" box
  dll $udll MoveCursor $calc($window(-3).x + 185) $calc( $window(-3).y - 15)

  ;Now we left-click it
  dll $udll Click left
}

; I like to do things like this. It saves me typing, and I can easily change it later in my entire script if I need to.
alias -l pris return @CursorPrison
alias -l udll return $scriptdir $+ cursor.dll
